PRO RECALCULATE, mstruc, datstruc
;
;	recalculate everything
;
;	SET CLEAR POLYNOMIAL PARAMETERS
;
	CASE mstruc.contyp OF
	'S': BEGIN
		npnts = mstruc.npnts
		swav1 = mstruc.swav1
		swav2 = mstruc.swav2
		wavel = mstruc.wavel
		ratio = mstruc.ratio

	    	TREMOVE, NPNTS, SWAV1, SWAV2, WAVEL, RATIO, const, slope, 1
		mstruc.cparam=[CONST,SLOPE,0.,0.]
	     END
	'T': BEGIN
		npnts = mstruc.npnts
		swav1 = mstruc.swav1
		swav2 = mstruc.swav2
		waven = mstruc.waven
		ratio = mstruc.ratio

	    	TREMOVE, NPNTS, SWAV1, SWAV2, WAVEN, RATIO, const, slope, 0
		mstruc.cparam=[CONST,SLOPE,0.,0.]
	     END
	ELSE:
	ENDCASE

	FILLUP, mstruc, datstruc         ; FILL UP THE ARRAYS

	RETURN
	END




PRO UPDATE, mstruc, nbands, p0, p1, p2

   IF N_PARAMS() GT 2 THEN BEGIN
      ;
      ; Adding an absorbtion feature to model struc
      ;
      nparam = 3*nbands + 4
      params = FLTARR( nparam )
      cmm    = FLTARR( nparam )

      cnrt = FLTARR(nbands)
      sgsq = FLTARR(nbands)

      oldbands  = mstruc.nbands
      oldnparam = mstruc.nparam

      ; Fill in the values of the other parameters in the new arrays

      pdx = INDGEN( nbands,3 )
      odx = REFORM( pdx(0:oldbands-1,*), 3*oldbands )

      params( odx )                 = mstruc.params( 0:oldnparam-5 )
      params( pdx(nbands-1,*) )     = [p0(0), p1(0), p2(0)]
      params( nparam-4:nparam-1 )   = mstruc.params( oldnparam-4:oldnparam-1 )

      cmm( odx )                    = mstruc.cmm( 0:oldnparam-5 )
      cmm( pdx(nbands-1,*) )        = [p0(1), p1(1), p2(1)]
      cmm( nparam-4:nparam-1 )      = mstruc.cmm( oldnparam-4:oldnparam-1 )


      ; Redefine model structure

      newroot  = { cnrt: FLTARR(nbands), $
		   sgsq: FLTARR(nbands) }

      newstruc = { fitfile: mstruc.fitfile, $
           datdir: mstruc.datdir, $
           dfile: mstruc.dfile, $
           datfile: mstruc.datfile, $
		   wconst: mstruc.wconst, $
		   contyp: mstruc.contyp, $
		   cparam: mstruc.cparam, $
		   sparam: mstruc.sparam, $
		   swav1:  mstruc.swav1, $
		   swav2:  mstruc.swav2, $
		   rmslim: mstruc.rmslim, $
		   rimplim: mstruc.rimplim, $
		   gcent: [mstruc.gcent, p0(0)], $
		   gfwhm: [mstruc.gfwhm, p1(0)], $
		   gstr:  [mstruc.gstr, p2(0)], $
		   scent: [mstruc.scent, p0(1)], $
		   sfwhm: [mstruc.sfwhm, p1(1)], $
		   sstr:  [mstruc.sstr, p2(1)], $
		   gcentn: [mstruc.gcentn, 0.], $
		   gwidth: [mstruc.gwidth, 0.], $
		   params: params, $
		   nparam: nparam, $
		   nbands: nbands, $
		   cmm: cmm, $
		   ipstat: INTARR(nparam,2), $
		   roots: newroot }

      FILSTAT, newstruc, ipstat
      newstruc.ipstat = ipstat
      mstruc = newstruc

   ENDIF ELSE BEGIN

      new_nbands = mstruc.nbands - 1
      pdx = indgen( mstruc.nbands,3 )
      ngauss = indgen( mstruc.nbands ) + 1
      gdx = WHERE( ngauss NE nbands )

      index = pdx( gdx,* )
      index = REFORM( index, n_elements(index), /OVERWRITE )

      params = [mstruc.params(index), $
		mstruc.params(mstruc.nparam-4:mstruc.nparam-1)]
      cmm    = [mstruc.cmm(index), $
	 	mstruc.cmm(mstruc.nparam-4:mstruc.nparam-1)]

      nparam = N_ELEMENTS( params )
      gcent  = mstruc.gcent(gdx)
      gfwhm  = mstruc.gfwhm(gdx)
      gstr   = mstruc.gstr(gdx)
      gcentn = mstruc.gcentn(gdx)
      gwidth = mstruc.gwidth(gdx)
      scent  = mstruc.scent(gdx)
      sfwhm  = mstruc.sfwhm(gdx)
      sstr   = mstruc.sstr(gdx)

      ; Redefine model structure

      newroot  = { cnrt: FLTARR(new_nbands), $
		   sgsq: FLTARR(new_nbands) }

      newstruc = { fitfile: mstruc.fitfile, $
           datdir: mstruc.datdir, $
           dfile: mstruc.dfile, $
           datfile: mstruc.datfile, $
		   wconst: mstruc.wconst, $
		   contyp: mstruc.contyp, $
		   cparam: mstruc.cparam, $
		   sparam: mstruc.sparam, $
		   swav1:  mstruc.swav1, $
		   swav2:  mstruc.swav2, $
		   rmslim: mstruc.rmslim, $
		   rimplim: mstruc.rimplim, $
		   gcent: gcent, $
		   gfwhm: gfwhm, $
		   gstr:  gstr, $
		   scent: scent, $
		   sfwhm: sfwhm, $
		   sstr:  sstr, $
		   gcentn: gcentn, $
		   gwidth: gwidth, $
		   params: params, $
		   nparam: nparam, $
		   nbands: new_nbands, $
		   cmm: cmm, $
		   ipstat: INTARR(nparam,2), $
		   roots: newroot }

      FILSTAT, newstruc, ipstat
      newstruc.ipstat = ipstat
      mstruc = newstruc

   ENDELSE

   RETURN
   END


PRO chpar, mstruc, datstruc
;
;	subroutine to change cont,baseline, or band parameters
;
;	ipmin,ipmax,ivtic   for  display
;	ihmin,ihmax,ihtic   for display
;	baseline constant
;	type of continuum   g gauss  p polynomial   n none  s straight line
;       p0,p1,p2  for continuum
;	number of bands
;	center in nm   fwhm in inverse cm    intensity
;	center in nm   fwhm in inverse cm    intensity
;	center in nm   fwhm in inverse cm    intensity
;	etc
;
	DoAgain = 1

	WHILE DoAgain DO BEGIN

	   itime = SYSTIME()

	   PRINT, itime, $
	       FORMAT = "(4X,A,4X,'=====  Change MGM-Fit Parameters  =====')"
;
;	   now write menu
;
	   PRINT, '  Select:  1 - Change Continuum Type'
	   PRINT, '           2 - Change Continuum Parameters'
	   PRINT, '           3 - Change An Absorption'
	   PRINT, '           4 - Add An Absorption'
	   PRINT, '           5 - Delete An Absorption'
	   PRINT, '           6 - Display'
	   PRINT, '           7 - Main Menu   > '

	   I1 = ''
	   READ, I1
	   IF (I1 EQ '') THEN RETURN

	   CASE FIX(i1) OF
	   1: BEGIN
;
;	   	change continuum type
;
		validcont = ['N','P','Q','G','S','T']

		PRINT, ''
		CASE mstruc.contyp OF
		'N': PRINT, ' No Continuum'
		'P': PRINT, ' Polynomial Continuum in Wavelength Space '
		'Q': PRINT, ' Polynomial Continuum in Wavenumber Space '
		'G': PRINT, ' Gaussian Continuum '
		'S': PRINT, mstruc.swav1, mstruc.swav2, $
		        FORMAT="(' Straight line removed in Wavelength ',2F7.0)"
		'T': PRINT, mstruc.swav1, mstruc.swav2, $
		        FORAMT="(' Straight line removed in Wavenumber ',2F7.0)"
		ELSE:
		ENDCASE
		PRINT, ''

		ans = ''
		READ, ans, $
		      PROMPT=' Enter new continuum type (N,P,Q,G,S,T): '

		ans = STRTRIM(STRUPCASE(ans),2)
		IF ans EQ ' ' OR ans EQ '' THEN $
		    PRINT, 'WARNING - Not a valid choice!' $
		ELSE BEGIN
		    vdx = WHERE( STRTRIM(STRUPCASE(ans),2) EQ validcont, iflag )
		    IF iflag EQ 0 THEN $
		        PRINT, 'WARNING - Not a valid choice!' $
		    ELSE $
		        mstruc.contyp = STRTRIM(STRUPCASE(ans),2)
		ENDELSE
	      END
	   2: BEGIN
;
;		change continuum parameters
;
                Pform="(' P0= ',E15.8,'  P1= ',E15.8,'  P2= ',E15.8,'  P3= ',E15.8)"

		CASE mstruc.contyp OF
		'N': ; no parameters to change
		'P': PRINT, mstruc.cparam, FORMAT=PForm
		'Q': PRINT, mstruc.cparam, FORMAT=PForm
		'S': PRINT, mstruc.swav1, mstruc.swav2, $
		        FORMAT="(' Straight line removed in Wavelength ',2F7.0)"
		'T': PRINT, mstruc.swav1, mstruc.swav2, $
		        FORAMT="(' Straight line removed in Wavenumber ',2F7.0)"
		ELSE:
		ENDCASE

		READ, p0, p1, p2, p3, $
		      FORMAT="(4E15.7)", $
		      PROMPT = 'Enter continuum parameters- p0, p1, p2, p3: '

		IF (mstruc.contyp EQ 'S' OR $
		   mstruc.contyp EQ 'T') THEN BEGIN
;
;			STRAIGHT LINE REASSIGN
;
			IF p0 NE 0 THEN mstruc.swav1 = p0
			IF p1 NE 0 THEN mstruc.swav2 = p1

		ENDIF ELSE $
		IF (mstruc.contyp EQ 'P' OR $
		   mstruc.contyp EQ 'Q') THEN BEGIN
;
;			POLYNOMIAL REASSIGN
;
			IF p0 NE 0. THEN mstruc.cparam(0) = p0
			IF p1 NE 0. THEN mstruc.cparam(1) = p1
			IF p2 NE 0. THEN mstruc.cparam(2) = p2
			IF p3 NE 0. THEN mstruc.cparam(3) = p3
		ENDIF

		RECALCULATE, mstruc, datstruc
	      END
	   3: BEGIN
;
;		change a band parameters
;
		IF mstruc.nbands GT 1 THEN BEGIN
		    READ, k, $
		      	FORMAT="(i4)", $
 		      	PROMPT=' Which Absorption Band (1 - ' + $
			   	STRTRIM(mstruc.nbands,2) + ') ? '
		ENDIF ELSE k = 1

		IF (k GT 0) AND (k LE mstruc.nbands) THEN BEGIN

		    GForm1 = "(2X,I2,'  Center= ',E15.8"
		    GForm2 = ",'   FWHM= ',E15.8,'   Str= ',E16.8)"
		    GForm  = GForm1 + GForm2

		    PRINT, k, $
		       mstruc.gcent(k-1), $
		       mstruc.gfwhm(k-1), $
		       mstruc.gstr(k-1), $
		       FORMAT=GForm

		    READ, p0, p1, p2, $
		      FORMAT="(4E15.7)", $
		      PROMPT=' Enter band parameters- Center,Width,Strength: '

		    IF p0 NE 0 THEN mstruc.gcent(k-1) = p0
		    IF p1 NE 0 THEN mstruc.gfwhm(k-1) = p1
		    IF p2 NE 0 THEN mstruc.gstr(k-1)  = p2

		    RECALCULATE, mstruc, datstruc

		ENDIF
	      END
	   4: BEGIN
;
;		add an absorption
;
		p0 = FLTARR(2)
		p1 = FLTARR(2)
		p2 = FLTARR(2)

		AFORM = "(2E15.7)"
		READ, p0, FORMAT = AFORM, PROMPT = ' Enter Center and Uncertainty in NM: '
		READ, p1, FORMAT = AFORM, PROMPT = ' Enter FWHM and Uncertainty in NM : '
		READ, p2, FORMAT = AFORM, PROMPT = ' Enter Strength and Uncertainty: '
;
;		move other params to temp arrays
;
		UPDATE, mstruc, mstruc.nbands+1, p0, p1, p2
;
;		need to re-define size of datstruc.gauss to compensate for
;		additional band...

		newdatstruc = { ratio: datstruc.ratio, $
		     wavel: datstruc.wavel, $
		     waven: datstruc.waven, $
		     daterror: datstruc.daterror, $
		     wvrt:  datstruc.wvrt, $
		     fit:   datstruc.fit, $
		     cont:  datstruc.cont, $
		     resid: datstruc.resid, $
		     rcont: datstruc.rcont, $
		     remain: datstruc.remain, $
		     gline: datstruc.gline, $
		     gauss: FLTARR(datstruc.npnts,mstruc.nbands), $
		     npnts: datstruc.npnts }
		datstruc = newdatstruc

		RECALCULATE, mstruc, datstruc
	      END
	   5: BEGIN
;
;		delete an absorption
;
		IF mstruc.nbands GT 1 THEN BEGIN
		    READ, k, $
		      FORMAT="(i4)", $
		      PROMPT= ' Which Absorption to delete (1 - ' + $
			      STRTRIM(mstruc.nbands,2) + ') ? '
		ENDIF ELSE k=1

		IF (k GT 0) AND (k LE mstruc.nbands) THEN BEGIN

		    GForm1 = "(2X,I2,'  Center= ',E15.8"
		    GForm2 = ",'   FWHM= ',E15.8,'   Str= ',E16.8)"
		    GForm  = GForm1 + GForm2

		    PRINT, k, $
		       mstruc.gcent(k-1), $
		       mstruc.gfwhm(k-1), $
		       mstruc.gstr(k-1), $
		       FORMAT=GForm

		    ans = ''
		    READ, ans, $
		      PROMPT = ' Delete This Absorption (y/n)? '

		    IF STRUPCASE(ans) EQ 'Y' THEN BEGIN
;
;			delete Absorption # k
;
			UPDATE, mstruc, k
;
;			need to re-define size of datstruc.gauss to
;			compensate for additional band...

			newdatstruc = { ratio: datstruc.ratio, $
		     			wavel: datstruc.wavel, $
		     			waven: datstruc.waven, $
		     			daterror: datstruc.daterror, $
		     			wvrt:  datstruc.wvrt, $
		     			fit:   datstruc.fit, $
		     			cont:  datstruc.cont, $
		     			resid: datstruc.resid, $
		     			rcont: datstruc.rcont, $
		     			remain: datstruc.remain, $
		     			gline: datstruc.gline, $
		     			gauss: FLTARR(datstruc.npnts,$
						      mstruc.nbands), $
		     			npnts: datstruc.npnts }
					datstruc = newdatstruc

			RECALCULATE, mstruc, datstruc
		    ENDIF
		ENDIF
	      END
	   6: BEGIN
	 	DISPLAY, mstruc, datstruc
	      END
	   7: DoAgain = 0
	   ELSE:
	   ENDCASE

	   PRINT, ''
	   PRINT, ''
	ENDWHILE
	RETURN
	END
