PRO SHUFFL, mstruc, datstruc, params
;
;	subroutine to fill the param array
;


	wconst=mstruc.wconst
;
;	FIRST CONVERT WAVEL TO WAVEN AND FWHM TO WIDTH
;
	ndx = WHERE( datstruc.waven ne 0, iflag )
	IF iflag GT 0 THEN $
	   datstruc.WVRT(ndx) = 1.0/datstruc.waven(ndx)*1e7

	mstruc.gcentn = WLtoWN(mstruc.gcent)		  ; convert to wavenumber
	mstruc.gwidth = mstruc.gfwhm/WCONST

	ndx = WHERE( mstruc.gcentn ne 0, iflag )
	IF iflag GT 0 THEN mstruc.roots.cnrt(ndx) = 1.0/mstruc.gcentn(ndx)*1e7

 	SGRT = mstruc.GWIDTH              		; to be determined
	mstruc.roots.SGSQ = SGRT*SGRT*(-2.0)    	; -2.0 * SIGMA SQUARED
;
;	FILL THE PARAM ARRAY
;	1-nbands ARE CENTERS
;	nbands+1 - 2nbands ARE WIDTHS
;	2nbands+1 - 3bands ARE STRENGTHS
;
	nbands = mstruc.nbands
	nparam = 3*nbands + 4
	params = fltarr( nparam )

	FOR K=0,nbands-1 DO BEGIN
	    PARAMS(K)       	   = mstruc.GCENTN(K)
	    PARAMS(nbands+K)	   = mstruc.GWIDTH(K)
	    PARAMS(nbands+nbands+K)= mstruc.GSTR(K)
	ENDFOR
;
;	STORE THE CONT/BASELINE PARAMS
;
	PARAMS(NPARAM-4:NPARAM-1) = mstruc.cparam 

	mstruc.param0=params   		; store the original parameters 
	RETURN
	END


PRO FILLUP, mstruc, datstruc
;
;	subroutine to FILL ALL THE GFIT ARRAYS
;
	wconst=mstruc.wconst

	SHUFFL, mstruc, datstruc, params
;
;	THEN BUILD THE INDIVIDUAL BANDS
;
	GAUSS = DBLARR( datstruc.npnts, mstruc.nbands)

	FOR K=0,mstruc.nbands-1 DO BEGIN
	    GAUSS(*,K) = CGAUSS( mstruc.roots.CNRT(K), $
			         mstruc.roots.SGSQ(K), $
				 mstruc.GSTR(K), $
				 datstruc.WVRT )
	ENDFOR
;
;	CALCULATE SUM OF THE BANDS
;
	gline = TOTAL( gauss, 2 )
;
;	SET CLEAR CONTINUUM POLYNOMIAL PARAMETERS
;
	CASE mstruc.contyp OF
	'P': BEGIN			; polynomial in wavelength space
		w = datstruc.WAVEL
		ws = w*w
		wc = w*ws
		cont = mstruc.cparam(0) + $
		       ( mstruc.cparam(1)*w ) + $
		       ( mstruc.cparam(2)*ws) + $
		       ( mstruc.cparam(3)*wc) 
		cont = ALOG( cont )
	     END
	'Q': BEGIN			; polynomial in wavenumber space
		w = datstruc.WAVEN
		ws = w*w
		wc = w*ws
		cont = mstruc.cparam(0) + $
		       ( mstruc.cparam(1)*w ) + $
		       ( mstruc.cparam(2)*ws) + $
		       ( mstruc.cparam(3)*wc) 
		cont = ALOG( cont )
	     END
	'S': BEGIN			; STRAIGHT LINE REMOVAL IN WAVEL SPACE
		w = datstruc.WAVEL
		ws = w*w
		wc = w*ws
		cont = mstruc.cparam(0) + $
		       ( mstruc.cparam(1)*w ) + $
		       ( mstruc.cparam(2)*ws) + $
		       ( mstruc.cparam(3)*wc) 
		cont = ALOG( cont )
	     END
	'T': BEGIN			; STRAIGHT LINE IN WAVEN SPACE
		w = datstruc.WAVEN
		ws = w*w
		wc = w*ws
		cont = mstruc.cparam(0) + $
		       ( mstruc.cparam(1)*w ) + $
		       ( mstruc.cparam(2)*ws) + $
		       ( mstruc.cparam(3)*wc) 
		cont = ALOG( cont )
	     END
	ELSE: cont = FLTARR( datstruc.npnts )	; No Continuum
	ENDCASE
;
;	CALCULATE FIT LINE
;
	fit = cont + gline
;
;	CALCULATE RESIDUAL AND REMAIN
;
	RESID = datstruc.RATIO - FIT
	RCONT = datstruc.RATIO - CONT

	datstruc.gline  = gline
	datstruc.cont   = cont
	datstruc.gauss  = gauss
	datstruc.fit    = fit
	datstruc.resid  = resid
	datstruc.rcont  = rcont
	mstruc.params   = params

	RETURN
	END
