PRO LISTPAR, mstruc, datstruc
;
;	subroutine to list all the parameters to the screen
;
;	ipmin,ipmax,ivtic   for  display
;	ihmin,ihmax,ihtic   for display
;	baseline constant
;	type of continuum   g gaussain  p polynomial   n none  s straight line
;       p0,p1,p2  for continuum
;	number of gaussians
;	center in nm   fwhm in inverse cm    intensity
;	center in nm   fwhm in inverse cm    intensity
;	center in nm   fwhm in inverse cm    intensity
;	etc
;
;
	CATCH, Error_status
	IF Error_status NE 0 THEN RETURN

	idate = SYSTIME()

	PRINT, idate, $
	       FORMAT="(//1X,A,8X,'=====  MGM-Fit Parameters  ====='//)"
;
;	now dump out the current parameters
;
;
;	baseline continuum list	
;	
	CASE mstruc.contyp OF 
	'N': PRINT, ' No Continuum'
	'P': PRINT, ' Polynomial Continuum in Wavelength Space '
	'Q': PRINT, ' Polynomial Continuum in Wavenumber Space '
	'G': PRINT, ' Gaussian Continuum '
	'S': PRINT, mstruc.swav1, mstruc.swav2, $
		        FORMAT="(' Straight line removed in Wavelength ',2F7.1)"
	'T': PRINT, mstruc.swav1, mstruc.swav2, $
		        FORAMT="(' Straight line removed in Wavenumber ',2F7.1)"
	ELSE:
	ENDCASE

	IF (mstruc.contyp ne 'N') THEN $
	   PRINT, mstruc.cparam, $
	       FORMAT="(' P0= ',E15.8,' P1= ',E15.8,' P2= ',E15.8,' P3= ',E15.8)"
;
;	now list bands
;
	PRINT, mstruc.nbands, $
	       FORMAT="(/2X,I4,' Absorption Bands'/)"
   
	FOR k = 0,mstruc.nbands-1 DO $
	PRINT, k+1, mstruc.gcent(k), mstruc.gfwhm(k), mstruc.gstr(k), $
	   FORMAT="(2X,I2,'  Center= ',E15.8,'   FWHM= ',E15.8,'   Str= ',E16.8)"
;
;	write error
;
	rmscur=RMSERR( datstruc.FIT, datstruc.RATIO )

	PRINT, rmscur, FORMAT="(/' Current RMS Error ',E13.6)"

	idum = ''
	READ, idum			;Force a CR before continuing
	return
	end
