PRO LISTSTAT, mstruc
;
;	subroutine to list locked/unlocked status of all the parameters
;	to the screen
;
;	ipmin,ipmax,ivtic   for  display
;	ihmin,ihmax,ihtic   for display
;	baseline constant
;	type of continuum   g gaussian  p polynomial   n none  s straight line
;       p0,p1,p2  for continuum
;	number of bands
;	center in nm   fwhm in inverse cm    intensity
;	center in nm   fwhm in inverse cm    intensity
;	center in nm   fwhm in inverse cm    intensity
;	etc
;
	idate = SYSTIME()

	PRINT, idate, $
	       FORMAT="(//1X,A,8X,'=====  Parameter Status  =====')"
;
;	now dump out the current parameters
;
;	now list bands
;
	PRINT, $
	       FORMAT="(//,28X,' Absorption Bands'/)"
	PRINT, $
	       FORMAT="(4X,'#',9X,'Center',11X,'FWHM',12X,'Strength'/)"
 
	pdx    = INDGEN(mstruc.nbands,3)
	setpar = STRARR( mstruc.nbands,3 )+'Unlocked'
 
	FOR k = 0,mstruc.nbands-1 DO BEGIN

	   ndx = WHERE( mstruc.ipstat( pdx(k,*) ) GT 0, iflag )
	   IF iflag GT 0 THEN setpar(k,ndx) = ' Locked '

	   value = STRING( REFORM(setpar(k,*)), FORMAT="(A8,9X,A8,8X,A8)" )

	   PRINT, k+1, value, $
	          FORMAT="(2x,i3,'+',8x,A)"
	ENDFOR
;
;	write error
;
	IF mstruc.contyp NE 'N' THEN BEGIN
	   setpar = STRARR( 4 ) + 'Unlocked'
	   ndx = WHERE( mstruc.ipstat( mstruc.nparam-4:mstruc.nparam-1,0 ) GT 0, $
			iflag )
	   IF iflag GT 0 THEN setpar( ndx ) = ' Locked '

	   PRINT, 'Continuum Parameters', $
         	  FORMAT="(/,A,10X,'C0',11X,'C1',11X,'C2',11X,'C3'/)"
	   PRINT, setpar, $
		  FORMAT="(27X,4(A8,5X))"

	ENDIF

	idum = ''
	READ, idum			;Force a CR before continuing
	RETURN
	END
