PRO LOCKUP, mstruc
;
;	subroutine to  lock/onlock parameters
;
;	ipmin,ipmax,ivtic   for  display
;	ihmin,ihmax,ihtic   for display
;	baseline constant
;	type of continuum   g gauss  p polynomial   n none  s straight line
;       p0,p1,p2  for continuum
;	number of absorptions 
;	center in nm   fwhm in inverse cm    intensity
;	center in nm   fwhm in inverse cm    intensity
;	center in nm   fwhm in inverse cm    intensity
;	etc
;
	TryAgain = 1
	WHILE TryAgain DO BEGIN

	   itime = SYSTIME()
	   PRINT, itime, $
	       FORMAT="(4X,A,3X,'=====  Lock/Unlock MGM-Fit Parameters  =====')"
;
;	   now write menu
;
	   PRINT, '  Select:  1 - Lock All Bandcenters'
	   PRINT, '           2 - Unlock All Bandcenters'
	   PRINT, '           3 - Lock All Bandwidths'
	   PRINT, '           4 - Unlock All Bandwidths'
	   PRINT, '           5 - Lock All Strengths'
	   PRINT, '           6 - Unlock All Strengths'
	   PRINT, '           7 - Lock Polynomial Constants'
	   PRINT, '           8 - Unlock Non-Zero Polynomials'
	   PRINT, '           9 - Lock An Individual Parameter'
	   PRINT, '          10 - Unlock An Individual Parameter'
	   PRINT, '          11 - Lock An Individual Absorption'
	   PRINT, '          12 - Unlock An Individual Absorption'
	   PRINT, '          13 - Display Current Parameter Status'
	   PRINT, '          14 - Exit       > '

	   I1 = ''
	   READ, I1
	   IF (I1 EQ '') THEN RETURN
	
	   CASE FIX(i1) OF
	   1: BEGIN			; lock centers
	   	cdx = INDGEN(mstruc.nbands)
	   	mstruc.ipstat(cdx,0) = 1
	      END
	   2: BEGIN			; unlock centers
		cdx = INDGEN(mstruc.nbands)
		mstruc.ipstat(cdx,0) = 0
	      END
	   3: BEGIN			; lock widths
		cdx = INDGEN(mstruc.nbands) + mstruc.nbands
		mstruc.ipstat(cdx,0) = 1
	      END
	   4: BEGIN			; unlock widths
		cdx = INDGEN(mstruc.nbands) + mstruc.nbands
		mstruc.ipstat(cdx,0) = 0
	      END
	   5: BEGIN			; lock strengths
		cdx = INDGEN(mstruc.nbands) + mstruc.nbands + mstruc.nbands
		mstruc.ipstat(cdx,0) = 1
	      END
	   6: BEGIN			; unlock strengths
		cdx = INDGEN(mstruc.nbands) + mstruc.nbands + mstruc.nbands
		mstruc.ipstat(cdx,0) = 0
	      END
	   7: BEGIN			; lock polynomial parameters
		mstruc.ipstat(mstruc.nparam-4:mstruc.nparam-1,0) = 1
	      END
	   8: BEGIN			; unlock nonzero polynomial parameters
		ndx = WHERE( mstruc.cparam GT 0, iflag )
		IF iflag GT 0 THEN BEGIN
			index = INDGEN(4) + mstruc.nparam - 4
			mstruc.ipstat(index(ndx),0) = 0
		ENDIF
	      END
	   9: BEGIN			; lock an individual parameter
		reprompt  = 1

		WHILE reprompt DO BEGIN
		    nband = mstruc.nbands
		    PRINT, '  Centers are    1 - ' + STRTRIM(nband,2)
		    PRINT, '  Widths  are    ' + STRTRIM(nband+1,2) + $
		   	' - ' + STRTRIM( 2*nband,2 )
		    PRINT, '  Strengths are  ' + STRTRIM(2*nband+1,2) + $
		 	' - ' + STRTRIM( 3*nband,2 )
		    PRINT, '  CpN   is       ' + STRTRIM(3*nband+1,2) + $
			' - ' + STRTRIM( mstruc.nparam,2 ) + ' >  '

		    READ, ipar, FORMAT="(i4)", PROMPT= ' Enter Parameter ID: '

		    IF (ipar GT mstruc.nparam) THEN $
			reprompt = 1 ELSE $
			reprompt = 0
		ENDWHILE
		IF (ipar GE 1) AND (ipar LE mstruc.nparam) THEN $
		    mstruc.ipstat(ipar-1,0) = 1
	      END
	  10: BEGIN			; unlock an individual parameter
		reprompt  = 1

		WHILE reprompt DO BEGIN
		    nband = mstruc.nbands
		    PRINT, '  Centers are    1 - ' + STRTRIM(nband,2)
		    PRINT, '  Widths  are    ' + STRTRIM(nband+1,2) + $
		   	' - ' + STRTRIM( 2*nband,2 )
		    PRINT, '  Strengths are  ' + STRTRIM(2*nband+1,2) + $
		 	' - ' + STRTRIM( 3*nband,2 )
		    PRINT, '  CpN   is       ' + STRTRIM(3*nband+1,2) + $
			' - ' + STRTRIM( mstruc.nparam,2 ) + ' >  '

		    READ, ipar, FORMAT="(i4)", PROMPT= ' Enter Parameter ID: '

		    IF (ipar GT mstruc.nparam) THEN $
			reprompt = 1 ELSE $
			reprompt = 0
		ENDWHILE
		IF (ipar GE 1) AND (ipar LE mstruc.nparam) THEN $
		    mstruc.ipstat(ipar-1,0) = 0
	      END
	  11: BEGIN			; lock an absorption
		reprompt = 1

		WHILE reprompt DO BEGIN
		    READ, ipar, $
		          FORMAT="(i4)", $
		          PROMPT=' Lock Absorption #? '

		    IF (ipar GT mstruc.nbands) THEN $
			reprompt = 1 ELSE $
			reprompt = 0
		ENDWHILE
		IF (ipar GE 1) AND (ipar LE mstruc.nbands) THEN BEGIN
		    pdx = INDGEN(mstruc.nbands,3)
		    mstruc.ipstat( pdx(ipar-1,*),0 ) = 1
		ENDIF
	      END
	  12: BEGIN			; unlock an absorption
		reprompt = 1

		WHILE reprompt DO BEGIN
		    READ, ipar, $
		          FORMAT="(i4)", $
		          PROMPT=' UnLock Absorption #? '

		    IF (ipar GT mstruc.nbands) THEN $
			reprompt = 1 ELSE $
			reprompt = 0
		ENDWHILE
		IF (ipar GE 1) AND (ipar LE mstruc.nbands) THEN BEGIN
		    pdx = INDGEN(mstruc.nbands,3)
		    mstruc.ipstat( pdx(ipar-1,*),0 ) = 0
		ENDIF
	      END
	  13: LISTSTAT, mstruc
	  14: TryAgain = 0
	  ELSE: 
	  ENDCASE

	ENDWHILE
	RETURN
	END		
