PRO MGM
;
;	roots contain par **-2.0
;
STARTUP, mstruc, datstruc
sz = SIZE( mstruc )
IF (sz( sz(0)+1 ) NE 8) THEN BEGIN
	RETURN
ENDIF

;
;	SET INITIAL ERROR LIMITS
;
IRESL = ABS( datstruc.WAVEL(1)-datstruc.WAVEL(0) )
IF IRESL LE 1 THEN IRESL=1
IFITRES = IRESL
ISAMPRES = IFITRES/IRESL   		; CALCULATE FIT FREQUENCY
RMSOLD = RMSERR( datstruc.FIT, datstruc.RATIO )
;	RMSLIM=0.0020     		; <1/4 % RMS ERROR
;	RIMPLIM=1.0E-8    		; SET IMPROVEMENT LIMIT TO 7 SIG FIG

fitflag = 0;
DoAgain = 1
WHILE DoAgain DO BEGIN

   IDATE = SYSTIME()

   PRINT, ''
   PRINT, ''
   PRINT, '          ======= MGM-FIT 2.0  Main Menu ========'
   PRINT, ''
   PRINT, '   By Jessica Sunshine and Stephen Pratt -- Brown University'
   PRINT, '   ', IDATE
   PRINT, ''
   PRINT, '   Select: 1-Display Current Parameters'
   PRINT, '           2-Fit Once
   PRINT, '           3-Fit Until'
   PRINT, '           4-Add/Del/Ch a Parameter'
   PRINT, '           5-Lock/Unlock a Parameter'
   PRINT, '           6-Display Routines'
   PRINT, '           7-Storage Routines (Ref.)'
   PRINT, '           8-Storage Routines (Log)'
   PRINT, '           9-Display Parameter Status'
   PRINT, '          10-Set Fit Resolution'
   PRINT, '          11-Stop '

   selection = ''
   READ, selection
   IF (selection EQ '') THEN selection = 11

   CASE FIX(selection) OF
   1: BEGIN				; LIST CURRENT PARAMETERS
	LISTPAR, mstruc, datstruc
      END
   2: BEGIN				; CALL FITTING ONCE
	STOCFIT, mstruc, datstruc, ISAMPRES, 0
	fitflag = 1;
      END
   3: BEGIN				; CALL FITTING MULTI
	STOCFIT, mstruc, datstruc, ISAMPRES, 1
	fitflag = 1;
      END
   4: BEGIN				; CHANGE/DEL/ADD A BAND
	CHPAR, mstruc, datstruc
      END
   5: BEGIN				; LOCK/UNLOCK PARAMETERS
	LOCKUP, mstruc
      END
   6: BEGIN				; DISPLAY PLOT
	DISPLAY, mstruc, datstruc
      END
   7: BEGIN				; STORING PARAMETERS (Ref)
	STORCURV1, mstruc, datstruc
      END
   8: BEGIN				; STORING PARAMETERS (Log)
	STORCURV2, mstruc, datstruc
      END
   9: BEGIN				; LISTING PARAMETERS
	LISTSTAT, mstruc
      END
   10: BEGIN				;SETTING FIT RESOLUTION
	IRESL = ABS( datstruc.WAVEL(1)-datstruc.WAVEL(0) )
	PRINT, IRESL,IFITRES, $
	   FORMAT="(' Spectrum Resolution',I4,' Nm.  Fitting Resolution',I4,' Nm.')"

	READ, IFITRES, $
	      FORMAT="(I6)", $
  	      PROMPT=' Enter Fitting Resolution in Nanometers: '

	IF IFITRES LT 1 THEN IFITRES=IRESL
	ISAMPRES = FIX( IFITRES/IRESL )   	; CALCULATE FIT FREQUENCY
	IF ISAMPRES LE 1 THEN ISAMPRES=1
       END
   11: BEGIN
	IF !D.WINDOW GE 0 THEN $
	   WDELETE, 0

	IF fitflag THEN DUMPAR, mstruc, datstruc
	DoAgain = 0
       END
   ELSE:
   ENDCASE

ENDWHILE
RETURN
END
