FUNCTION PGAUSS, X0, width, zintens, X, ipart
;
;	single precision version for partial derivatives
;
;	subroutine to compute partial derivatives of gaussians
;
;	if ipart=1   derivative/center
;	   ipart=2   derivative/width
;	   ipart=3   derivative/intensity
;
;
	xdif=x-x0                ; supplied wave are x**-.2
	xsq=xdif*xdif
	sigma=width
	sigsq=sigma*sigma

	CASE ipart OF
;
;	evaluate partial derivative with respect to center
;
	0:	pg=(xdif/sigsq)*(-1.0*x0^2.0)/1.0E7  ; change magnitude
;
;	evaluate partial derivative with respect to width
;
	1:	pg=xsq/(sigsq*sigma)
;
;	evaluate partial derivative with respect to strength
;
	2:	pg=1.0/zintens
	ELSE:	print, 'No such partial derivative!'
	ENDCASE
	return, pg
   	end
