;
;	double precision version
;
FUNCTION PGAUSSD, X0, width, zintens, X, ipart
;
;	double precision version for partial derivatives
;
;	subroutine to compute partial derivatives of gaussians
;
;	if ipart=1   derivative/center
;	   ipart=2   derivative/width
;	   ipart=3   derivative/intensity
;
;
	xdif=DOUBLE(x)-DOUBLE(x0)                ; supplied wave are x**-.2
	xsq=xdif*xdif
	sigma=DOUBLE(width)
	sigsq=sigma*sigma

	CASE ipart OF
;
;	evaluate partial derivative with respect to center
;
	0:	pgauss=(xdif/sigsq)*(-1.0*x0^2.0)/1.0E7  ; change magnitude
;
;	evaluate partial derivative with respect to width
;
	1:	pgauss=xsq/(sigsq*sigma)
;
;	evaluate partial derivative with respect to strength
;
	2:	pgauss=1.0/DOUBLE(zintens)
	ELSE:	print, 'No such partial derivative!'
	ENDCASE
	return, pgauss
   	end

