PRO STARTUP, mstruc, datstruc
;
;	subroutine to get initial data for gfit
;
;	routine reads in initial file and parameters from a startup file
;	with extension .fit
;
	wconst= 2.354820

;	FitFile = DIALOG_PICKFILE( GET_PATH=dirpath, FILTER='*.fit', /MUST_EXIST )
;	IF STRLEN( FitFile ) EQ 0 THEN BEGIN
;	   mstruc = 0
;	   RETURN
;	ENDIF

	FEXT='.fit'
	start = ''

        retry = 0
	REPEAT BEGIN
	   noretry = 1
	   READ, start, PROMPT=' Enter Startup File Name: '

	   FitFile = STRTRIM(start,2) + FEXT

	   ipos = STRPOS( FitFile, '~' )

	   IF ipos GE 0 THEN BEGIN
		FitFile = Expand_Tilde( FitFile )
	   ENDIF

	   gstart = FINDFILE( fitfile, count=nfile )
	   IF nfile EQ 0 THEN BEGIN
		PRINT, ''
		PRINT, 'File does not exist!!'
		mstruc = 0
		noretry = 0
		retry = retry + 1
		IF retry GT 2 THEN BEGIN
		   RETURN
		ENDIF
	   ENDIF
	ENDREP UNTIL noretry
;
;	OPEN UP THE STARTUP FILE AND READ IN THE MODEL INFO
;
	mstruc = READ_FITFILE( FitFile )
	NBANDS = mstruc.nbands
	NPARAM = mstruc.nparam		; 3 params/gaussian + 4 for continuum

; 	INITIALIZE PARAMETERS
;
;	create cmm diagonals from est. model stnd dev.
;
	cmm = FLTARR( NPARAM )

	mstruc.sCENT = WLtoWN( mstruc.gcent - mstruc.sCENT ) - $
		       WLtoWN( mstruc.gcent + mstruc.sCENT )
	mstruc.sFWHM = mstruc.sFWHM/WCONST
;
;	FILL THE PARAM ARRAY
;	    1-NBANDS           ARE CENTERS
;	    NBANDS+1 - 2NBANDS ARE WIDTHS
;	    2NBANDS+1 - 3BANDS ARE STRENGTHS
;
	FOR k = 0,NBANDS-1 DO BEGIN
	   cmm(K) 		= mstruc.sCENT(K)
	   cmm(NBANDS+K)	= mstruc.sfwhm(K)
	   cmm(NBANDS+NBANDS+K)	= mstruc.sSTR(K)
	ENDFOR

	cmm(NPARAM-4:NPARAM-1) = mstruc.sparam
	mstruc.cmm = cmm

	FILSTAT, mstruc, ipstat                	; fill in the types of partials
	ipstat(*,0) = 0        			; unlock all parameters
;	ipstat(nparam-4:nparam-1,0) = 1		; lock continuum stuff
	mstruc.ipstat = ipstat
;
;	NOW READ IN DATA FILE AND WRITE OUT TEXT
;
;	DATFile = FINDFILE( mstruc.datfile, COUNT=nfile )
;	IF nfile EQ 0 THEN BEGIN
;	   PRINT, ''
;	   PRINT, 'Data file does not exist: ' + mstruc.datfile
;	   PRINT, 'Check file path!'
;	   mstruc = 0
;	   RETURN
;	ENDIF

	READ_DATAFILE, mstruc.datfile, datarr

	errors = 'n'
	IF N_ELEMENTS( datarr(*,0) ) GT 2 THEN BEGIN
	   PRINT, ''
	   READ, errors, PROMPT= "Use Errorbars (y or n) ?  "
	ENDIF
	IF errors EQ 'y' or errors EQ 'Y' THEN BEGIN
	   daterror = datarr(2,*)
	ENDIF ELSE $
	   daterror = MAKE_ARRAY( N_ELEMENTS(datarr(0,*)),/FLOAT, VALUE=1 )
	RATIO = ALOG( REFORM(datarr(1,*)) )         ; CONVERT TO LOG REF

	WAVEL = REFORM( datarr(0,*) )		    ; input data in Nanometers
	WAVEN = WLtoWN( WAVEL )			    ; CONVERT TO WAVENUMBER
;
;	CREATE DATA STRUCTURE
;
	npnts = N_ELEMENTS( ratio )

	datstruc = { ratio: ratio, $
		     wavel: wavel, $
		     waven: waven, $
		     daterror: daterror, $
		     wvrt:  fltarr(npnts), $
		     fit:   fltarr(npnts), $
		     cont:  fltarr(npnts), $
		     resid: fltarr(npnts), $
		     rcont: fltarr(npnts), $
		     remain: fltarr(npnts), $
		     gline: fltarr(npnts), $
		     gauss: dblarr(npnts,mstruc.nbands), $
		     npnts: npnts }

	FILLUP, mstruc, datstruc       ; FILL UP THE ARRAYS

	RETURN
	END
