FUNCTION ERROR_CHECK, mstruc, datstruc, rmsold, rmsnew, itimes

	COMMON Local$Com, facti, mchs, oldpar, itr, ddx, ppp

	; CHECK TO SEE IF WE HAVE A WINNER

	FAILURE=1./(2.0^15)            ; BACKOFF FAILURE POINT
	keepgoing = 1
	itry=0   			; number of times backoff applied

	WHILE (rmsnew GE rmsold) DO BEGIN			; worse off
;
;	    if new params are worse apply interpolation factor
;
	    itry=itry+1
	    PRINT, itry, $
		FORMAT="('+',' Applying Binary Backoff to Correction  ',I4)"

	    facti=facti/2.0    			; compute interpolation factor

	    IF (facti LT FAILURE) THEN BEGIN   	; INTERPOLATION FAILS
;
;	    	RESTORE OLDPAR
;
	    	mstruc.PARAMS=OLDPAR
	    	UNSHUFFL, mstruc
	    	FILLUP, mstruc, datstruc

	    	PRINT, '  Interpolation by Binary Backoff Fails !!'
	    	RETURN, 0
	    ENDIF ELSE BEGIN 			; recalulate
	    	mstruc.PARAMS(ppp) = OLDPAR(ppp) + ( facti*mchs )  

	        UNSHUFFL, mstruc
	        FILLUP, mstruc, datstruc

	        rmsnew = RMSERR( datstruc.fit(ddx), datstruc.ratio(ddx) )
	    ENDELSE
	ENDWHILE

;	PRINTF, lun, ''
;	PRINTF, lun, ''
;	PRINTF, lun, mstruc.cparam, FORMAT="(7(2X,E15.8))"
;	PRINTF, lun, mstruc.nbands, FORMAT="(1X,I2)"

;	FOR k = 0, mstruc.nbands-1 DO BEGIN
;	    PRINTF, lun, $
;		mstruc.gcent(k), $
;		mstruc.gfwhm(k), $
;		mstruc.gstr(k), $
;		FORMAT="(7(2X,E16.8))"
;	ENDFOR

	itr=itr+1
	rmsimp=rmsold-rmsnew
;	PRINTF, lun, $
;		rmsold, $
;		rmsnew, $
;		rmsimp, $
;		FORMAT="('    Old RMS',E14.6,'   New RMS=',E14.6,'   Imp=',E14.6)"

	PRINT, itr, $
	       rmsold, $
	       rmsnew, $
	       rmsimp, $
	       FORMAT="('+ ',I5,'   Old RMS',E14.6,'   New RMS=',E14.6,'   Imp=',E14.6)"
;
;	check for and invert negative widths
;
;	 sigma gets squared so keep positive
;
	pdx = INDGEN(mstruc.nbands,3)
	nnn = WHERE( mstruc.params( pdx(*,1) ) LT 0, iflag )

	IF iflag GT 0 THEN BEGIN

	   FOR jj = 0,iflag-1 DO BEGIN
		PRINT, nnn(jj)+1, $
		       FORMAT="(/,'  Band #',I3,' has a negative width !!!'/)"
	   ENDFOR

	ENDIF

	mstruc.params( pdx(*,1) ) = ABS( mstruc.params( pdx(*,1) ) )
;
;	check for positive strengths
;
	nnn = WHERE( mstruc.params( pdx(*,2) ) GT 0, iflag )

	IF iflag GT 0 THEN BEGIN

	   FOR jj = 0,iflag-1 DO BEGIN
		PRINT, nnn(jj)+1, $
		       FORMAT="(/,'  Band #',I3,' has a positive strength !!!'/)"
	   ENDFOR

	ENDIF

	IF (rmsimp LE mstruc.rimplim) THEN $
		PRINT, '  Improvement in rms less than limit !!'
	IF (rmsnew LE mstruc.rmslim) THEN $
		PRINT, '  Rms less than limit !!'

	IF (ITIMES EQ 0) THEN keepgoing = 0	; ONE TIME FIT ONLY

	IF (rmsimp LE mstruc.rimplim) THEN $
		keepgoing = 0			; IMPROVEMENT LIMIT REACHED

	IF (rmsnew LE mstruc.rmslim) THEN $
		keepgoing = 0              	; RMS LIMIT REACHED

RETURN, keepgoing
END




PRO SPIT_IT_OUT, mstruc, rmscur, ppp, inparam, G


  ipos = STRPOS( mstruc.FITfile, '.fit' )
  finalfile = STRMID( mstruc.FITfile, 0, ipos ) + '_fin.fit'
  OPENW, lun2, finalfile, /GET_LUN

  PRINTF, lun2, mstruc.DATDir
  PRINTF, lun2, mstruc.DFile
  PRINTF, lun2, mstruc.YRange(0)*100, mstruc.YRange(1)*100, $
		mstruc.YRange(2)*100, FORMAT = "(i4,', ',i4,', ',i4)"
  PRINTF, lun2, mstruc.XRange(0)*1000, mstruc.XRange(1)*1000, $
		mstruc.YRange(2)*1000, FORMAT="(i4, ', ',i4, ', ',i4)"
  PRINTF, lun2, mstruc.rmslim, mstruc.rimplim, $
		FORMAT="(f6.3,', ',e10.2)"
  PRINTF, lun2, mstruc.contyp

;
;	calculate GTG
;
  gtg = TRANSPOSE(g) # g
;
;	get GTGinv
;	
  gtginv = INVERT( gtg )
;
;   	print out gtg diagonals
;
  nparus = N_ELEMENTS(ppp)
  mstruc.std = FLTARR( inparam )
  FOR i=0,nparus-1 DO $
 	 mstruc.std(ppp(i)) = 1.96*SQRT( FLOAT( gtginv(i,i) )* $  ; 1.96*st dev
			     rmscur^2 )		      ; 95% conf.
;
;	baseline continuum list	
;	
  IF ( mstruc.contyp NE 'N') THEN BEGIN
	ndx = WHERE( mstruc.cparam NE 0., ncpar )
	uncert = mstruc.std( inparam-ncpar:inparam-1 )
	IF ncpar LT 4 THEN $
		uncert = [uncert, FLTARR( 4-ncpar )]

	PRINTF, lun2, mstruc.cparam, FORMAT="(4e15.6)"
	PRINTF, lun2, uncert, FORMAT="(4e15.6)"
  ENDIF

  PRINTF, lun2, mstruc.nbands, FORMAT="(i2)"
;
;	now list bands...
;
  wconst= 2.354820;
  uncert = mstruc.std( 0:mstruc.nbands-1 )
  cntmax=1.0/(1.0/mstruc.gcent-uncert*1E-7)
  cntmin=1.0/(1.0/mstruc.gcent+uncert*1E-7)
  FOR k = 0,mstruc.nbands-1 DO BEGIN
	PRINTF, lun2, mstruc.gcent(k), $
			mstruc.gfwhm(k), $
			mstruc.gstr(k), $
			FORMAT="(4e15.6)"
	PRINTF, lun2, uncert(k), $
			mstruc.std( mstruc.nbands+k ), $
			mstruc.std( 2*mstruc.nbands+k ), $
			FORMAT="(4e15.6)"
  ENDFOR

  CLOSE, lun2
  FREE_LUN, lun2
RETURN
END







PRO STOCFIT, mstruc, datstruc, ISAMPRES, ITIMES 
;
;	subroutine to CALCULATE BEST FIT
;          using stochastic non-linear inverse
;          Tarantola & Vallete (1982) Reviews in Geophysics

COMMON values, param0
COMMON Local$Com, facti, mchs, oldpar, itr, ddx, ppp

; Initialize
facti  	= 0
mchs   	= 0
oldpar 	= 0
itr 	= 0
ddx 	= -1
ppp 	= -1

;OPENW, lun, 'for003.dat', /GET_LUN


WCONST=mstruc.wconst
;
;	Create an index array into data array based on fit frequency
;
FOR i=0,datstruc.npnts-1,ISAMPRES DO BEGIN
	IF ddx(0) LT 0 THEN $
	   ddx = i ELSE $
	   ddx = [ddx,i]
ENDFOR
	
keepgoing = 1

WHILE keepgoing DO BEGIN

	FACTI=1.0
;
;	SAVE OLDPAR
;
	OLDPAR=mstruc.PARAMS
;
;	COMPUTE BEST FIT FOR SINGLE BAND
;
	inparam=mstruc.NPARAM

	ndx = WHERE( mstruc.cparam EQ 0, iflag )
	inparam = inparam-iflag
;
;	BUILD THE PARTIAL DERIVAIVE MATRIX
;
;	NPARUS = number of parameters used in fit (i.e., all UNLOCKED params)
;
	ppp = WHERE( mstruc.ipstat(0:inparam-1,0) EQ 0, nparus )
	g   = DBLARR( N_ELEMENTS(ddx), nparus )

	FOR i=0,nparus-1 DO BEGIN

	   ipart1=mstruc.ipstat(ppp(i),1)    ; SECOND COLUMN CONTAINS DERIVATIVES
;
;	   FIND OUT WHAT KIND OF DERIVATIVE WE NEED
;
	   CASE ipart1 OF
;
;	   COMPUTE ALL THE PARTIALS 
;
	   4: BEGIN				; LINEAR OF POLYNOMIAL
		g(*,i) = 1.0 / EXPON( datstruc.cont(ddx) )
	      END
	   5: BEGIN				; X TERM OF POLYNOMIAL
		IF (mstruc.CONTYP EQ 'Q' OR $
		    mstruc.CONTYP EQ 'T') THEN BEGIN
			value = datstruc.waven(ddx) 
		ENDIF ELSE $	
		IF (mstruc.CONTYP EQ 'P' OR $
		    mstruc.CONTYP EQ 'S') THEN BEGIN
			value = datstruc.wavel(ddx)
		ENDIF
		g(*,i) = value / EXPON( datstruc.cont(ddx) )
	      END
	   6: BEGIN				; X SQUARED TERM OF POLYNOMIAL
		IF (mstruc.CONTYP EQ 'Q' OR $
		    mstruc.CONTYP EQ 'T') THEN BEGIN
			value = datstruc.waven(ddx) 
		ENDIF ELSE $	
		IF (mstruc.CONTYP EQ 'P' OR $
		    mstruc.CONTYP EQ 'S') THEN BEGIN
			value = datstruc.wavel(ddx)
		ENDIF

		g(*,i) = (value * value) / EXPON( datstruc.cont(ddx) )
	      END
	   7: BEGIN				; X CUBED TERM OF POLYNOMIAL
		IF (mstruc.CONTYP EQ 'Q' OR $
		    mstruc.CONTYP EQ 'T') THEN BEGIN
			value = datstruc.waven(ddx) 
		ENDIF ELSE $	
		IF (mstruc.CONTYP EQ 'P' OR $
		    mstruc.CONTYP EQ 'S') THEN BEGIN
			value = datstruc.wavel(ddx)
		ENDIF

		g(*,i) = (value * value * value) / EXPON( datstruc.cont(ddx) )
	      END
	    ELSE: BEGIN				; Gaussian parameters
;
;	  	IS A BAND WHICH BAND ?
;
;		Set up an array to identify which band we're working on...
;
		pdx = INTARR( mstruc.nbands,3 )
		FOR b = 0,mstruc.nbands-1 DO $
		    pdx( b,*) = b

		in1 = pdx(ppp(i))

	  	TINV = datstruc.GAUSS(ddx,IN1)
	  	g(*,i) = PGAUSS( mstruc.roots.CNRT(IN1), $
				   mstruc.GWIDTH(IN1), $
				   mstruc.GSTR(IN1), $
				   datstruc.WVRT(ddx), $
				   IPART1-1 )

	  	g(*,i) = g(*,i) * TINV
	      END
	   ENDCASE
	ENDFOR
;
;	calculate inv(covariance matrix) for model parameters
;
	cmminv      = IDENTITY(nparus, /DOUBLE)
	ndx         = WHERE( cmminv EQ 1. )
        cmminv(ndx) = ( 1.0/( mstruc.cmm(ppp)/1.96 )^2 )     
	                ; var=(error @95% conf/1.96)^2

	errors=WHERE (datstruc.daterror NE 1)
	IF errors(0)  NE -1 THEN $
	   cnnvarinv= 1.0/(datstruc.daterror(ddx)/ $
		mean(datstruc.daterror(ddx))) $
	ELSE $
	  cnnvarinv = datstruc.daterror
	cnninv = MAKE_ARRAY(n_elements(ddx),nparus,/DOUBLE, value=1.0)
	FOR i=0, nparus-1 DO $
	  cnninv(*,i) = cnninv(*,i) *cnnvarinv
;
;	calculate GTG
;
	gtg = TRANSPOSE(g) #(cnninv* g)
;
;	get GTGmminv  inv(gtg + inv(cmm))
;
	gtgmminv = INVERT( gtg + cmminv )
;
;	inv(cmm) * difference between model now & original model
;
	mtemp1 = cmminv # ( oldpar(ppp) -mstruc.param0(ppp) )
;
;	gt * residual fit
;
	mtemp2 = TRANSPOSE(g) # (cnnvarinv*datstruc.resid(ddx))

	mtemp2 = mtemp2 - mtemp1
;
;	calculate new model params gtgmminv * mtemp2
;
	mchs = gtgmminv # mtemp2
;
;	FORM NEW SOLUTIONS
;
; 	get current err
;
	rmsold = RMSERR( datstruc.fit(ddx),datstruc.ratio(ddx) )   
;
;	IF PARAMETER IS UNLOCKED ADD ON CORRECTION
;
	mstruc.params(ppp) = oldpar(ppp) + FLOAT(mchs)
;
;	NOW MOVE PARAMS BACK TO ORIGINAL ARRAYS
;
	UNSHUFFL, mstruc
	FILLUP, mstruc, datstruc		   	          ; recalulate curve

	rmsnew = RMSERR( datstruc.fit(ddx),datstruc.ratio(ddx) )  ; get new error
;
;	see if calculation was an improvement
;
	keepgoing = ERROR_CHECK( mstruc, $
				 datstruc, $
				 rmsold, $
				 rmsnew, $
				 itimes )
ENDWHILE
SPIT_IT_OUT, mstruc, rmsnew, ppp, inparam, g
;CLOSE, lun
;FREE_LUN, lun
idum = ''
READ, idum
RETURN
END
