PRO STORCURV1, mstruc, datstruc
;
;	There will be 2 files written out, one for the spectra of the individual
;	bands, and one containing the five following spectra: fit, continuum, 
;	combined absorptions, residual (spec-fit), spec-continuum.
; 
	itime = SYSTIME()

	PRINT, itime, $
	  FORMAT="(6X,A,4X,'======  Relectance Storage Routine  ======')"

	head = ''
	READ, head, $
	      PROMPT='  Enter Header for Data Files (4 Char Max.) '
	head = STRMID( head,0,4 )

; 	File #1: Individual Bands...

	file = head + 'BNDS'
	WRITEGAUSS, datstruc.wavel, $
		    EXPON(datstruc.gauss), $
		    file, $
		    mstruc.gcent, $
		    mstruc.gfwhm, $
		    EXPON( mstruc.gstr )

; 	File #2: Everything else...

	npnts = datstruc.npnts

	EXT='.asc'
	FILOUT = head + 'DATA' + EXT
	OPENW, lun, filout, /GET_LUN

	PRINTF, lun, '; File created: '+itime
	PRINTF, lun, ';'
	PRINTF, lun, '; Columns = (1) Energy,     (2) Fit,      (3) Continuum'
	PRINTF, lun, ';           (4) Cmb. Bands, (5) Spec-Fit, (6) Spec-Cont.'
	PRINTF, lun, ';'

	FOR i = 0, npnts-1 DO BEGIN
		rtemp = EXPON( datstruc.ratio(i) ) - EXPON( datstruc.fit(i) )
		PRINTF, lun, datstruc.wavel(i), $
			     EXPON( datstruc.fit(i) ), $
			     EXPON( datstruc.cont(i) ), $
			     EXPON( datstruc.gline(i) ), $
			     rtemp, $
			     EXPON( datstruc.rcont(i) ), $
			     FORMAT="(6F12.6)"

	ENDFOR
	CLOSE, lun
	FREE_LUN, lun
	RETURN
	END	
 	   

