PRO STORCURV2, mstruc, datstruc
;
;	STORE STUFF IN LOG BASE E
;
	itime = SYSTIME()

	PRINT, itime, $
	  FORMAT="(6X,A,4X,'======  Log Base e Storage Routines  ======')"

	head = ''
	READ, head, $
	      PROMPT='  Enter Header for Data Files (4 Char Max.) '
	head = STRMID( head,0,4 )

;	There will be 2 files written out, one for the spectra of the individual
;	bands, and one containing the five following spectra: fit, continuum, 
;	combined absorptions, residual (spec-fit), spec-continuum.
; 
; 	File #1: Individual Bands...

	file = head + 'LBNDS'
	WRITEGAUSS, datstruc.wavel, $
		    datstruc.gauss, $
		    file, $
		    mstruc.gcent, $
		    mstruc.gfwhm, $
		    mstruc.gstr

; 	File #2: Everything else...

	npnts = datstruc.npnts

	EXT='.asc'
	FILOUT = head + 'LDATA' + EXT
	OPENW, lun, filout, /GET_LUN

	PRINTF, lun, '; File created: '+itime
	PRINTF, lun, ';'
	PRINTF, lun, ';                *** Log Base e Format **** '
	PRINTF, lun, ';'
	PRINTF, lun, '; Columns = (1) Energy,     (2) Fit,      (3) Continuum'
	PRINTF, lun, ';           (4) Cmb. Bands, (5) Spec-Fit, (6) Spec-Cont.'
	PRINTF, lun, ';'

	FOR i = 0, npnts-1 DO BEGIN
		rtemp = datstruc.ratio(i) - datstruc.fit(i)
		PRINTF, lun, datstruc.wavel(i), $
			     datstruc.fit(i), $
			     datstruc.cont(i), $
			     datstruc.gline(i), $
			     rtemp, $
			     datstruc.rcont(i), $
			     FORMAT="(6E15.6)"

	ENDFOR
	CLOSE, lun
	FREE_LUN, lun

	RETURN
	END	
